#!/usr/bin/python
# -*- coding: utf-8 -*-

#
# Logik verze 1.1, Copyright (C) 2006 Jan Fuchs <fuky@sunstel.asu.cas.cz>
#
# Logik je ABSOLUTNĚ BEZ ZÁRKUKY. Jde o volné programové vybavení a jeho šíření
# za jistých podmínek je vítáno; podrobnosti získáte v Obecné veřejné licenci
# GNU.
#

import Tkinter
import random
import sys

platno = None
pozice = None
run = False
kod = []
tip = []
pole = []
barva = [ "white", "black", "red", "green", "blue", "yellow" ]

SIZE_BIG = 34
SIZE_SMALL = 17
PADDING = 6

def vyhodnoceni(text, color):
  platno.create_rectangle(0, 0, WIDTH, SIZE_BIG * 3 - 5, fill="white", outline="white")
  platno.create_text(WIDTH / 2, 30, font=("system-dependent", 20), text=text, fill=color)

def paint(x, y, size, color, typ=None):
  x = x * size
  y = y * size
  
  if (typ == None):
    x += PADDING / 2
    y += PADDING / 2
    platno.create_oval(x, y, x + size - PADDING, y + size - PADDING, fill=color)
  else:
    platno.create_rectangle(x, y, x + size, y + size, fill=color)

def start(event):
  global run, pozice, kod, tip

  for i in range(10):
    pole.append([0, 0, 0, 0])
  
  platno.create_rectangle(0, 0, WIDTH, HEIGHT, fill="white", outline="white")
     
  for i in range(0, 10, 2):
    y1 = 3 * SIZE_BIG + i * SIZE_BIG
    y2 = y1 + SIZE_BIG
    platno.create_rectangle(0, y1, WIDTH, y2, fill="#DDDDDD", outline="")
    
  for i in range(6):
    paint(i + 1, 1, SIZE_BIG, "", "ctverec")
    paint(i + 1, 1, SIZE_BIG, barva[i])
  
  for i in range(10):
    for j in range(4):
      paint(j + 3, i + 3, SIZE_BIG, "", "ctverec")
    
  for i in range(4):
    paint(3 + i, 14, SIZE_BIG, "", "ctverec")
     
  for i in range(10):
    paint(2, 6 + i * 2, SIZE_SMALL, "", "ctverec")
    paint(3, 6 + i * 2, SIZE_SMALL, "", "ctverec")
    paint(2, 7 + i * 2, SIZE_SMALL, "", "ctverec")
    paint(3, 7 + i * 2, SIZE_SMALL, "", "ctverec")
  
  kod = [-3, -3, -3, -3]
  tip = [-4, -4, -4, -4]
  for i in range(4):
    kod[i] = random.randrange(0, 6)
  #kod = [0, 4, 2, 3]
  pozice = 0
  run = True

def click(event):
  global run, pozice, tip

  x = event.x / SIZE_BIG
  y = event.y / SIZE_BIG
    
  if (run and (x > 0) and (x < 7) and (y == 1)):
    x -= 1
    radek = pozice / 4
    sloupec = pozice % 4
    tip[sloupec] = x
    paint(sloupec + 3, radek + 3, SIZE_BIG, barva[x])

    bily = 0
    cerny = 0
    kod_tmp = []
    kod_tmp.extend(kod)
    if (sloupec == 3):
      for i in range(4):
        if (kod_tmp[i] == tip[i]):
          kod_tmp[i] = -1
          tip[i] = -2
          bily += 1

      for i in range(4):
        for j in range(4):
          if (kod_tmp[j] == tip[i]):
            kod_tmp[j] = -1
            tip[i] = -2
            cerny += 1
            break
      
      color = "black"
      for i in range(1, bily + cerny + 1):
        if (i > bily):
          color = "white"
          
        if (i == 1):
          paint(2, 6 + radek * 2, SIZE_SMALL, color)
        elif (i == 2):
          paint(3, 6 + radek * 2, SIZE_SMALL, color)
        elif (i == 3):
          paint(2, 7 + radek * 2, SIZE_SMALL, color)
        elif (i == 4):
          paint(3, 7 + radek * 2, SIZE_SMALL, color)

    if ((sloupec == 3) and (bily == 4)):
      vyhodnoceni("Victory", "black")
      run = False

    if (pozice == 39):
      vyhodnoceni("Loss", "red")
      run = False

    if (not run):
      for i in range(4):
        paint(3 + i, 14, SIZE_BIG, barva[kod[i]])
  
    pozice += 1
  
def main():
  global platno, pole, SIZE_BIG, SIZE_SMALL, PADDING, WIDTH, HEIGHT

  if (len(sys.argv) == 2):
    if (sys.argv[1] in ("--small", "-s")):
      SIZE_BIG = 24
      SIZE_SMALL = 12
      PADDING = 6
    elif (sys.argv[1] in ("--big", "-b")):
      SIZE_BIG = 50
      SIZE_SMALL = 25
      PADDING = 10

  WIDTH = SIZE_BIG * 8
  HEIGHT = SIZE_BIG * 16

  okno = Tkinter.Tk()
  okno.wm_title("Logik 1.1")
  okno.maxsize(WIDTH, HEIGHT)
  okno.minsize(WIDTH, HEIGHT)
  
  platno = Tkinter.Canvas(okno, width=WIDTH, height=HEIGHT, background="white")
  platno.bind("<Button-1>", click)
  platno.bind("<Button-3>", start)
  platno.pack()
  
  platno.create_text(WIDTH / 2, HEIGHT / 4, font=("system-dependent", 55), text="Logik", fill="black")
  platno.create_text(WIDTH / 2, HEIGHT / 4 + 60, font=("system-dependent", 10),
                     text="Mouse button 3 = new game", fill="black")
  
  okno.mainloop()

if __name__ == '__main__':
  main()
